<?php
##############################
#                            #
#   ~~Gästebuch              #
#           Version: 4.0~~   #
#                            #
##############################

#######################
#                     #
#   Lizenzbedingung   #
#                     #
#######################
/*
Das Material des Gästebuchs steht unter der Creative-Commons-Lizenz Namensnennung 
- Weitergabe unter gleichen Bedingungen 3.0 Deutschland.
Um eine Kopie dieser Lizenz zu sehen, besuchen Sie http://creativecommons.org/licenses/by-sa/3.0/de/.
Das ursprüngliche Werk stammt von http://suchdichsatt.de/tutorial/php-gaestebuch.

Ausgenommen von dieser Lizenz ist der Captcha Ordner und die Smilies.
Die Smilies dürfen ohne Zustimmung der Betreiber von suchdichsatt.de 
nicht weitergegeben oder in einem anderen Script verwenden werden!
*/

function gb_sec_session_start() {	
	$session_name = SESSION_GB_NAME;   // Set a custom session name
	$secure = false;	// FOR DEVELOPMENT ONLY!!!! (https required)
	if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on') {
		$secure = true;
	}
    $httponly = true;	// This stops JavaScript being able to access the session id.
    // Forces sessions to only use cookies.
    if (ini_set('session.use_only_cookies', 1) === FALSE) {
		echo 'Error occured';
        exit();
    }
    // Gets current cookies params.
    $cookieParams = session_get_cookie_params();
    session_set_cookie_params($cookieParams["lifetime"],$cookieParams["path"],$cookieParams["domain"],$secure,$httponly);
    // Sets the session name to the one set above.
    session_name($session_name);
    session_start();            // Start the PHP session 
}

function gb_getWordLength($word) {
	return mb_strlen($word, 'UTF-8');	
}

function gb_getLayout($id, $style = 'width: 100%;') {
	$layout = array(
		'hr' =>			'<img src="' . $GLOBALS['folderPath'] . 'images/hr.png" style="' . $style . '" class="gb_hr" alt="hr" />'
	);
	return $layout[$id];
}


function gb_checkLogin() {
	if (isset($_SESSION[SESSION_GB_LOGIN]) && $_SESSION[SESSION_GB_LOGIN] == ADMIN_NAME && isset($_SESSION[SESSION_GB_PW]) && $_SESSION[SESSION_GB_PW] == ADMIN_PW) {
		return true;
	}
	return false;
}

function gb_redirect($page = '', $seconds = 2) {
	//return '<span id="redirectUrl" data-url="' . $page . '" data-time="' . $seconds * 1000 . '"></span>'; //JQuery Needed :/
	return '<meta http-equiv="refresh" content="' . $seconds . '; URL=' . $page . '">';
}

function gb_escapeStr($string) {
	$escapedString = htmlspecialchars($string);
	return $escapedString;
}

function checkInt($wert) {
	$checkit = preg_match("/^[0-9]+$/",$wert);
	if ($checkit) {
  		return true;
	}
  	return false;
}

function generateBbccode($smilies_pfad) {
	$ret = '';
	if ($GLOBALS['bbccode'] == 1) {
		$ret .= '
		<button type="button" class="gbBtn" tabindex="-1" onclick="insertText(\'[b]\',\'[/b]\')" title="[b][/b]"><b>b</b></button>
        <button type="button" class="gbBtn" tabindex="-1" onclick="insertText(\'[i]\',\'[/i]\')" title="[i][/i]"><i>i</i></button>
        <button type="button" class="gbBtn" tabindex="-1" onclick="insertText(\'[u]\',\'[/u]\')" title="[u][/u]"><u>u</u></button>
        <button type="button" class="gbBtn" tabindex="-1" onclick="insertURL()" title="[url][/url]">url</button>   
		';
	}
	if ($GLOBALS['smilies'] == 1) {
		$ret .= '<button type="button" class="gbBtn" tabindex="-1" onClick="window.open(\'' . $smilies_pfad . '\' , \'smilies\' , \'height=200,width=200,left=425,top=250\');">Smilies</button>';
	}
	if ($ret != '')
		$ret .= '<br />';
	return $ret;
}

function replaceSmilie($nachricht) {
	$search  = array(
		':D',
		'^^',
		':P',
		':o',
		':-/',
		';(',
		':(',
		'-.-'
	);
	$replace = array(
		'<img src="http://suchdichsatt.de/bilder/smilies/cool.png" style="width: 25px; height: 25px;" alt=":D" />',
		'<img src="http://suchdichsatt.de/bilder/smilies/smile.png" style="width: 25px; height: 25px;" alt="^^" />',
		'<img src="http://suchdichsatt.de/bilder/smilies/baeh.png" style="width: 25px; height: 25px;" alt=":P" />',
		'<img src="http://suchdichsatt.de/bilder/smilies/erstaunt.png" style="width: 25px; height: 25px;" alt=":o" />',
		'<img src="http://suchdichsatt.de/bilder/smilies/normal.png" style="width: 25px; height: 25px;" alt=":-/" />',
		'<img src="http://suchdichsatt.de/bilder/smilies/flame.png" style="width: 25px; height: 25px;" alt=";(" />',
		'<img src="http://suchdichsatt.de/bilder/smilies/traurig.png" style="width: 25px; height: 25px;" alt=":(" />',
		'<img src="http://suchdichsatt.de/bilder/smilies/boese.png" style="width: 25px; height: 25px;" alt="-.-" />'
	);
	return str_replace($search, $replace, $nachricht);	
}

//BBccode ersetzen in htmml tags
function replaceBbccode($nachricht) {
	$nachricht = preg_replace("/\[b\](.*)\[\/b\]/Usi", "<b>\\1</b>", $nachricht); 
	$nachricht = preg_replace("/\[i\](.*)\[\/i\]/Usi", "<i>\\1</i>", $nachricht);
	$nachricht = preg_replace("/\[u\](.*)\[\/u\]/Usi", "<u>\\1</u>", $nachricht);
	$nachricht = preg_replace("/\[url=(.*)\](.*)\[\/url]/Usi", "<a href='\\1' alt='\\1' info='\\1' title='\\1' target='_blank'>\\2</a>", $nachricht);
	return $nachricht;
}

function errorOutput($msg, $param = 0) {
	global $color;
	$ausgabe = '<p style="color: ' . $color . '; font-size: 12px;">' . $msg . '</p>';
	return $ausgabe;
}

function write_ini_file($assoc_arr, $path, $has_sections = FALSE) { 
    $content = ''; 
    if ($has_sections) { 
        foreach ($assoc_arr as $key => $elem) { 
            $content .= "[" . $key . "]\n"; 
            foreach ($elem as $key2 => $elem2) { 
                if (is_array($elem2)) { 
                    for ($i=0; $i < count($elem2); $i++) { 
                        $content .= $key2."[] = \"" . $elem2[$i] . "\"\n"; 
                    } 
                } 
				else if ($elem2 == "") $content .= $key2 . " = \n"; 
                else $content .= $key2 . " = \"" . $elem2 . "\"\n"; 
            } 
        } 
    } else { 
        foreach ($assoc_arr as $key=> $elem) { 
            if (is_array($elem)) { 
                for($i=0;$i<count($elem);$i++) { 
                    $content .= $key2."[] = \"" . $elem[$i] . "\"\n"; 
                } 
            } 
            else if($elem=="") $content .= $key2." = \n"; 
            else $content .= $key2 . " = \"" . $elem . "\"\n"; 
        } 
    } 

    if (!$handle = fopen($path, 'w')) { 
        return false; 
    } 
    if (!fwrite($handle, $content)) { 
        return false; 
    } 
    fclose($handle); 
    return true; 
}
?>