<?php
	##############################
	#                            #
	#   ~~Gästebuch              #
	#           Version: 4.0~~   #
	#                            #
	##############################
	
	//Ordner Pfad für die Gästebuch Textdateien angeben (Relativ zu dieser Datei)
	//Nur Sinnvoll, wenn es mehrere Dateien sind, sonst "database_3.1_to_4.0_converter_file" benutzen
	//Danach das Script im Browser aufrufen (PHP Compiler (z.B. Apache - PHP) vorrausgesetzt)
	$folder = './'; //Gleiches Verzeichnis wie diese Datei (./)
	$newFileDir = 'new'; //In diesem Ordner werden die umgewandelten Dateien abgelegt (keine Unterordner)
	
	#######################
	#                     #
	#   Lizenzbedingung   #
	#                     #
	#######################
	/*
	Das Material des Gästebuchs steht unter der Creative-Commons-Lizenz Namensnennung 
	- Weitergabe unter gleichen Bedingungen 3.0 Deutschland.
	Um eine Kopie dieser Lizenz zu sehen, besuchen Sie http://creativecommons.org/licenses/by-sa/3.0/de/.
	Das ursprüngliche Werk stammt von http://suchdichsatt.de/tutorial/php-gaestebuch.
	
	Ausgenommen von dieser Lizenz ist der Captcha Ordner und die Smilies.
	Die Smilies dürfen ohne Zustimmung der Betreiber von suchdichsatt.de 
	nicht weitergegeben oder in einem anderen Script verwenden werden!
	*/
	
	/////////////////////////
	//Nichts mehr editieren//
	/////////////////////////
	ini_set('error_reporting', E_ALL | E_STRICT);
	ini_set('display_errors', true);
	
	header('Content-type: text/html; charset=utf-8');
	
	echo 'Überpüfe Ordner nach Dateien...<br /><br />';
	
	if (!is_dir($newFileDir)) {
		mkdir($newFileDir, 0777, true); // true for recursive create
		echo 'Erstelle neuen Ordner für die umgewandelten Dateien...<br /><br />';
	}

	$files = scandir($folder); // Sortierung A-Z  
	foreach ($files as $file) {
		if (!is_file($folder . '/' . $file))
			continue;
			
		$fileInfo = pathinfo($folder . '/' . $file);
		if ($file == '.' || $file == '..'  || $file == '_notes' || $fileInfo['extension'] == 'php' || $fileInfo['basename'] == 'Thumbs.db')
			continue;
			
		echo 'Lese alte Datenbank - Textdatei: <b>' . $file . '</b><br />';
			
		if (!$fp = @fopen($file, 'r')) { //Öffnen des Textfeldes/Datenbank; @ = Unterdrückung der Fehlermeldung
			echo 'Die Textdatei ' . $file . ' konnte nicht geöffnet werden! (eventuell nicht gefunden?)<br /><br />';
			continue;
		}
		
		$output = '';
		$i = 0;
		while (!feof($fp)) { //Prüft ob der Dateizeiger am Ende der Datei angekommen ist
			$data = fgets($fp, 4096); //Liest bis zur angegebenen Länge oder einem Zeilenumbruch
			if (empty($data)) break;
			list ($date, $tag, $counter, $sender, $name, $message, $ip) = str_replace('\|', '|', preg_split('/(?<!\\\)(\|)/', $data));
			if ($i != 0)
				$output .= "\n";
			$output .= $counter . '|' . $date . '|' . $sender . '|' . $ip . '|' . $name . '|' . $message . '|';
			$i++;
		}
		fclose($fp);
		$output = str_replace("\r", '', $output);
		
		echo $i . ' Zeilen gefunden und umgewandelt.<br />';
		
		if (!$fp = @fopen($newFileDir . '/' . $file, 'wb')) { //Öffnen des Textfeldes/Datenbank; @ = Unterdrückung der Fehlermeldung
			echo 'Die Textdatei ' . $file . 'konnte nicht geöffnet werden!<br /><br />';
			continue;
		}
		$output = utf8_encode($output);
		//fwrite($fp, pack("CCC",0xef,0xbb,0xbf)); //UTF-8-DOM
		//fwrite($fp, "\xEF\xBB\xBF"); //UTF8-DOM
		fwrite($fp, $output);
		fclose($fp);
		echo 'Im Verzeichnis ' . $newFileDir . ' befindet sich nun eine Datei namens: ' . $file . '<br /><br />';
	}
?>